"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var util_1 = require("util");
var FormControlComponent = (function () {
    function FormControlComponent() {
        this.uniqueId = ++FormControlComponent.latestUniqueId;
    }
    Object.defineProperty(FormControlComponent.prototype, "control", {
        get: function () {
            if (!this.group || !this.field) {
                return;
            }
            return this.group.get(this.field.name);
        },
        enumerable: true,
        configurable: true
    });
    FormControlComponent.prototype.ngOnInit = function () {
    };
    FormControlComponent.prototype.isCustomEditor = function (field) {
        return field.editor instanceof Object;
    };
    FormControlComponent.prototype.isInput = function (field) {
        return !field.editor || util_1.isString(field.editor) && field.editor !== 'textarea';
    };
    FormControlComponent.prototype.isTextArea = function (field) {
        return field.editor === 'textarea';
    };
    FormControlComponent.prototype.isRequired = function (field) {
        return field.validators && field.validators.indexOf(forms_1.Validators.required) !== -1;
    };
    return FormControlComponent;
}());
FormControlComponent.latestUniqueId = new Date().getTime();
FormControlComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'ui-form-control',
                templateUrl: './form-control.component.html',
                styleUrls: ['./form-control.component.scss'],
            },] },
];
/** @nocollapse */
FormControlComponent.ctorParameters = function () { return []; };
FormControlComponent.propDecorators = {
    'group': [{ type: core_1.Input },],
    'field': [{ type: core_1.Input },],
};
exports.FormControlComponent = FormControlComponent;
//# sourceMappingURL=form-control.component.js.map